﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace EcrHost_CS.CommonCadWrapper
{
    class CloseTotalsRequest : EmptyTrx
    {
        public CloseTotalsRequest(int rootId, CloseTotalsIn ctr)
            : base(rootId, EmptyTrx.EMPTY_IN, GpeTrxClass.GPE_TRX_PURCHASE_CB_CID)
        {            
            int subTreeIn = GpePosLib.AddSubTree(prmTree, GpeRootTags.RTAG_SUM);
            checkNotNull(subTreeIn ,"CloseTotals: Add subSum TAG failed\n");
            // Debit-Payment
            checkNull(GpePosLib.AddIntTag(subTreeIn, GpeSubTags.STAG_DEBIT_COUNT, ctr.debitCnt), "CloseTotals: Add Debit Cnt Tag Err");
            checkNull(GpePosLib.AddStringTag(subTreeIn, GpeSubTags.STAG_DEBIT_SUM, ctr.getDebitSum()), "CloseTotals: Add Debit Sum Tag Err");
            // Credit-refund
            checkNull(GpePosLib.AddIntTag(subTreeIn, GpeSubTags.STAG_CREDIT_COUNT, ctr.creditCnt), "CloseTotals: Add Credit Cnt Tag Err");
            checkNull(GpePosLib.AddStringTag(subTreeIn, GpeSubTags.STAG_CREDIT_SUM, ctr.getCreditSum()), "CloseTotals: Add Credit Sum Tag Err");
            // Cash back
            checkNull(GpePosLib.AddIntTag(subTreeIn, GpeSubTags.STAG_CB_COUNT, ctr.cbCnt), "CloseTotals: Add CB Cnt Tag Err");
            checkNull(GpePosLib.AddStringTag(subTreeIn, GpeSubTags.STAG_CB_SUM, ctr.getCb()), "CloseTotals: Add CB Sum Tag Err");
        }        
    }

    public struct CloseTotalsIn
    {
        public int debitCnt;
        public long debitSum;
        public int creditCnt;
        public long creditSum;
        public int cbCnt;
        public long cbSum;

        public string getDebitSum() { return (getSum(debitSum)); }
        public string getCreditSum() { return (getSum(creditSum)); }
        public string getCb() { return (getSum(cbSum)); }

        private string getSum(long sum)
        {
            string strSum;
            if (sum >= 0)
                strSum = string.Format("+{0:000000000000000000}", sum);
            else
                strSum = string.Format("-{0:000000000000000000}", sum);
            return (strSum);
        }
    }
}
