﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.InteropServices;

namespace EcrHost_CS.CommonCadWrapper
{
    
    public static class GpePosLib
    {
        public delegate int pFcDispCb([param: MarshalAs(UnmanagedType.LPStr)] string pText, [param: MarshalAs(UnmanagedType.I4)]int codePageIdx, [param: MarshalAs(UnmanagedType.I4)]int tstFlg);
        public delegate int pFcPrnCb([param: MarshalAs(UnmanagedType.LPStr)] string pText, [param: MarshalAs(UnmanagedType.I4)]int codePageIdx, [param: MarshalAs(UnmanagedType.I4)]int imd, [param: MarshalAs(UnmanagedType.I4)]int tstFlg);
        public delegate int pFcDlgCb([param: MarshalAs(UnmanagedType.I4)]int dlgId, [param: MarshalAs(UnmanagedType.I4)]int tstFlg);

        [DllImport("GpeEcrCommLib.dll", EntryPoint = "_GpePosLib_OpenLibrary@4", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.StdCall)]
        [return: MarshalAs(UnmanagedType.I4)]
        public static extern int OpenLibrary([param: MarshalAs(UnmanagedType.LPStr)]string path);

        [DllImport("GpeEcrCommLib.dll", EntryPoint = "_GpePosLib_CloseLibrary@0", CallingConvention = CallingConvention.StdCall)]
        [return: MarshalAs(UnmanagedType.I4)]
        public static extern int CloseLibrary();

        [DllImport("GpeEcrCommLib.dll", EntryPoint = "_GpePosLib_GetVersion@0", CallingConvention = CallingConvention.StdCall)]
        [return: MarshalAs(UnmanagedType.I4)]
        public static extern int GetVersion();

        [DllImport("GpeEcrCommLib.dll", EntryPoint = "_GpePosLib_RegisterPrintCB@4", CallingConvention = CallingConvention.StdCall)]
        [return: MarshalAs(UnmanagedType.I4)]
        public static extern int RegisterPrintCB(pFcPrnCb cbPrint);

        [DllImport("GpeEcrCommLib.dll", EntryPoint = "_GpePosLib_RegisterDisplayCB@4", CallingConvention = CallingConvention.StdCall)]
        [return: MarshalAs(UnmanagedType.I4)]
        public static extern int RegisterDisplayCB(pFcDispCb cbDisply);

        [DllImport("GpeEcrCommLib.dll", EntryPoint = "_GpePosLib_RegisterDialogCB@4", CallingConvention = CallingConvention.StdCall)]
        [return: MarshalAs(UnmanagedType.I4)]
        public static extern int RegisterDialogCB(pFcDlgCb cbDialog);

        [DllImport("GpeEcrCommLib.dll", EntryPoint = "_GpePosLib_RunTransaction@8", CallingConvention = CallingConvention.StdCall)]
        [return: MarshalAs(UnmanagedType.I4)]
        public static extern int RunTransaction([param: MarshalAs(UnmanagedType.I4)] int classId, [param: MarshalAs(UnmanagedType.I4)] int rootId);

        [DllImport("GpeEcrCommLib.dll", EntryPoint = "_GpePosLib_CreatePrmTree@4", CallingConvention = CallingConvention.StdCall)]
        [return: MarshalAs(UnmanagedType.I4)]
        public static extern int CreatePrmTree([param: MarshalAs(UnmanagedType.I4)] int classId);

        [DllImport("GpeEcrCommLib.dll", EntryPoint = "_GpePosLib_ReleaseTree@4", CallingConvention = CallingConvention.StdCall)]
        [return: MarshalAs(UnmanagedType.I4)]
        public static extern int ReleaseTree([param: MarshalAs(UnmanagedType.I4)]int rootId);

        [DllImport("GpeEcrCommLib.dll", EntryPoint = "_GpePosLib_GetInputTree@4", CallingConvention = CallingConvention.StdCall)]
        [return: MarshalAs(UnmanagedType.I4)]
        public static extern int GetInputTree([param: MarshalAs(UnmanagedType.I4)]int tag);

        [DllImport("GpeEcrCommLib.dll", EntryPoint = "_GpePosLib_GetOutputTree@4", CallingConvention = CallingConvention.StdCall)]
        [return: MarshalAs(UnmanagedType.I4)]
        public static extern int GetOutputTree([param: MarshalAs(UnmanagedType.I4)]int tag);

        [DllImport("GpeEcrCommLib.dll", EntryPoint = "_GpePosLib_AddStringTag@12", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.StdCall)]
        [return: MarshalAs(UnmanagedType.I4)]
        public static extern int AddStringTag([param: MarshalAs(UnmanagedType.I4)]int treeId, [param: MarshalAs(UnmanagedType.I4)] int tag, [MarshalAs(UnmanagedType.LPStr)] string pValue);

        [DllImport("GpeEcrCommLib.dll", EntryPoint = "_GpePosLib_AddIntTag@12", CallingConvention = CallingConvention.StdCall)]
        [return: MarshalAs(UnmanagedType.I4)]
        public static extern int AddIntTag([param: MarshalAs(UnmanagedType.I4)]int treeId, [param: MarshalAs(UnmanagedType.I4)] int tag, [param: MarshalAs(UnmanagedType.I4)] int value);

        [DllImport("GpeEcrCommLib.dll", EntryPoint = "_GpePosLib_AddSubTree@8", CallingConvention = CallingConvention.StdCall)]
        [return: MarshalAs(UnmanagedType.I4)]
        public static extern int AddSubTree([param: MarshalAs(UnmanagedType.I4)] int treeId, [param: MarshalAs(UnmanagedType.I4)] int tag);

        [DllImport("GpeEcrCommLib.dll", EntryPoint = "_GpePosLib_GetStringTag@12", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.StdCall)]
        [return: MarshalAs(UnmanagedType.I4)]
        public static extern int GetStringTag([param: MarshalAs(UnmanagedType.I4)] int treeId, [param: MarshalAs(UnmanagedType.I4)] int tag, [MarshalAs(UnmanagedType.LPStr)] StringBuilder pValue);

        [DllImport("GpeEcrCommLib.dll", EntryPoint = "_GpePosLib_GetIntTag@8", CallingConvention = CallingConvention.StdCall)]
        [return: MarshalAs(UnmanagedType.I4)]
        public static extern int GetIntTag([param: MarshalAs(UnmanagedType.I4)] int treeId, [param: MarshalAs(UnmanagedType.I4)] int tag);

        [DllImport("GpeEcrCommLib.dll", EntryPoint = "_GpePosLib_GetSubTree@8", CallingConvention = CallingConvention.StdCall)]
        [return: MarshalAs(UnmanagedType.I4)]
        public static extern int GetSubTreeTag([param: MarshalAs(UnmanagedType.I4)] int treeId, [param: MarshalAs(UnmanagedType.I4)] int tag);        
    }

    public struct GpeTrxClass
    {
        public static int GPE_TRX_UNDEFINED_CID = 0;
        public static int GPE_TRX_PURCHASE_CID = 1;
        public static int GPE_TRX_PURCHASE_CB_CID = 2;
        public static int GPE_TRX_REFUND_CID = 3;
        public static int GPE_TRX_VOID_CID = 4;
        public static int GPE_TRX_PREAUTH_CID = 5;
        public static int GPE_TRX_PRE_COMPL_CID = 6;
        public static int GPE_TRX_CLOSE_TOTALS = 7;
        public static int GPE_TRX_SUB_TOTALS = 8;
        public static int GPE_TRX_NOT_UNKNOWN_CID = 9;
    }

    public struct GpeRootTags
    {
        public static int RTAG_ROOT = 0;
        public static int RTAG_TID = 1;
        public static int RTAG_TS = 2;
        public static int RTAG_AMT = 3;
        public static int RTAG_CB_AMT = 4;
        public static int RTAG_CUR = 5;
        public static int RTAG_AUTH_CODE = 6;
        public static int RTAG_CARD = 7;
        public static int RTAG_PAN = 8;
        public static int RTAG_RESPCODE = 9;
        public static int RTAG_INVOICE_NO = 10;
        public static int RTAG_EXPIRDATE = 11;
        public static int RTAG_CODEPAGE = 12;
        public static int RTAG_AID = 13;
        public static int RTAG_SQNO = 14;
        public static int RTAG_TRXNO = 15;
        public static int RTAG_SUM = 16;
        public static int RTAG_RECEIPT_1 = 17;
        public static int RTAG_RECEIPT_2 = 18;
        public static int RTAG_END = 99;
    }

    public struct GpeSubTags
    {
        public static int STAG_SUM_ROOT	= 100;
	    public static int STAG_DEBIT_COUNT = 101;
	    public static int STAG_DEBIT_SUM = 102;
	    public static int STAG_CREDIT_COUNT	= 103;
	    public static int STAG_CREDIT_SUM = 104;
	    public static int STAG_CB_COUNT	= 105;
	    public static int STAG_CB_SUM = 106;
        public static int STAG_SUM_END = 199;
    }

    public struct GpeDialogIdx
    {
        public static int DlgNone = 0;
        public static int DlgSignature  = 1;
    }


    public struct GpeTagLength
    {
        public static int TERMINAL_ID = 9;  //8+1
        public static int TIMESTAMP = 13;   //12+1
        public static int AUTH_CODE = 9;    //8+1
        public static int CARD_NAME = 21;   //20+1
        public static int PAN = 20;         //19+1
        public static int INVOICE_NR = 11;  //10+1
        public static int EXP_DATE = 5;     //4+1
        public static int AID = 25;         //24+1
        public static int SEQ_NR = 11;      //10+1
        public static int TRX_ID = 13;      //12+1
    }

    public struct GpeSumTagLength
    {
        public static int DEBIT_SUM     = 20;   //19+1
        public static int CREDIT_SUM    = 20;   //19+1
        public static int CB_SUM        = 20;   //19+1
    }
}
