﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace EcrHost_CS.CommonCadWrapper
{
    class PaymentRequest: EmptyTrx
    {
        public PaymentRequest(int rootId, Int32 inAmt, Int32 inAmtCb, Int32 inCurrency, String inInvoiceNr)
            : base(rootId, EmptyTrx.EMPTY_IN, GpeTrxClass.GPE_TRX_PURCHASE_CB_CID)
        {
            checkNotNull(inAmt, "Payment:Req: Amount is mandatory\n");
            checkNull(GpePosLib.AddIntTag(prmTree, GpeRootTags.RTAG_AMT, inAmt), "Payment: Add amount TAG failed\n");

            if (inInvoiceNr != null && inCurrency != 0 && inCurrency.ToString().Length > 0)
                checkNull(GpePosLib.AddIntTag(prmTree, GpeRootTags.RTAG_CUR, inCurrency), "Payment:Req:: Add currency TAG failed\n");

            if (inInvoiceNr != null && inInvoiceNr.Length > 0)
                checkNull(GpePosLib.AddStringTag(prmTree, GpeRootTags.RTAG_INVOICE_NO, inInvoiceNr), "Payment:Req:: Add invoice TAG failed\n");

            checkNotNull(inAmtCb, "Payment:Req: Cashback Amount is mandatory\n");
            checkNull(GpePosLib.AddIntTag(prmTree, GpeRootTags.RTAG_CB_AMT, inAmtCb), "Payment:Req:: Add cashback amount TAG failed\n");
        }

        public PaymentRequest(int rootId, Int32 inAmt, Int32 inCurrency, String inInvoiceNr)
            : base(rootId, EmptyTrx.EMPTY_IN, GpeTrxClass.GPE_TRX_PURCHASE_CID)
        {
            checkNotNull(inAmt, "Payment:Req: Amount is mandatory\n");
            checkNull(GpePosLib.AddIntTag(prmTree, GpeRootTags.RTAG_AMT, inAmt), "Payment: Add amount TAG failed\n");

            if (inInvoiceNr != null && inCurrency != 0 && inCurrency.ToString().Length > 0)
                checkNull(GpePosLib.AddIntTag(prmTree, GpeRootTags.RTAG_CUR, inCurrency), "Payment:Req:: Add currency TAG failed\n");

            if (inInvoiceNr != null && inInvoiceNr.Length > 0)
                checkNull(GpePosLib.AddStringTag(prmTree, GpeRootTags.RTAG_INVOICE_NO, inInvoiceNr), "Payment:Req:: Add invoice TAG failed\n");
        }
    }
}
