﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace EcrHost_CS.CommonCadWrapper
{
    public class PaymentResponse : EmptyTrx
    {
        private StringBuilder rsp_authCode = new StringBuilder(GpeTagLength.AUTH_CODE);
        private StringBuilder rsp_pan = new StringBuilder(GpeTagLength.PAN);
        private StringBuilder rsp_cardName = new StringBuilder(GpeTagLength.CARD_NAME);
        private StringBuilder rsp_uniqueTrnId = new StringBuilder(GpeTagLength.TRX_ID);
        private StringBuilder rsp_seqNr = new StringBuilder(GpeTagLength.SEQ_NR);
        private int respCode = 50;

        public PaymentResponse(int rootId)
            : base(rootId, EmptyTrx.EMPTY_OUT, GpeTrxClass.GPE_TRX_PURCHASE_CID)
        {
            respCode = getResponseCode();
            if (respCode <= 10 && respCode >= 0)
            {
                setAuthCode();
                setPan();
                setCardName();
                setUniqueTrnId();
            }
        }

        private void setAuthCode()
        {
            checkNull(GpePosLib.GetStringTag(prmTree, GpeRootTags.RTAG_AUTH_CODE, rsp_authCode), "Payment:Rsp: Authcode tag failed\n");
        }

        private void setPan()
        {            
            checkNull(GpePosLib.GetStringTag(prmTree, GpeRootTags.RTAG_PAN, rsp_pan), "Payment:Rsp: PAN tag failed\n");
        }

        private void setCardName()
        {
            checkNull(GpePosLib.GetStringTag(prmTree, GpeRootTags.RTAG_CARD, rsp_cardName), "Payment:Rsp: Card tag failed\n");
        }

        private void setUniqueTrnId()
        {            
            checkNull(GpePosLib.GetStringTag(prmTree, GpeRootTags.RTAG_TRXNO, rsp_uniqueTrnId), "Payment:Rsp: uniqueTrn tag failed\n");
        }

        private void setSeqNr()
        {
            int ret = GpePosLib.GetStringTag(prmTree, GpeRootTags.RTAG_SQNO, rsp_seqNr);
            if (ret != 0 && ret != -72)  // OK or Tag Not found
                throw new CommonCADWrapperEx("Payment:Rsp: seqNr tag failed\n");
        }

        public StringBuilder getAuthCode()
        {
            return (rsp_authCode);
        }

        public StringBuilder getPan()
        {
            return (rsp_pan);
        }

        public StringBuilder getCardName()
        {
            return (rsp_cardName);
        }

        public StringBuilder getUniqueTrnId()
        {
            return (rsp_uniqueTrnId);
        }

        public StringBuilder getSeqNr()
        {
            return (rsp_seqNr);
        }

        override public string ToString()
        {            
            string trnPaymentData = base.ToString();
            trnPaymentData += "PAN: "+getPan() + "\n";
            trnPaymentData += "AuthCode: " + getAuthCode() + "\n";
            trnPaymentData += "TrxId: " + getUniqueTrnId() + "\n";         
            return(trnPaymentData);
        }

    }
}
