﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace EcrHost_CS.CommonCadWrapper
{
    class RefundRequest : EmptyTrx
    {
        public RefundRequest(int rootId, Int32 inAmt, Int32 inCurrency, String inInvoiceNr)
            : base(rootId, EmptyTrx.EMPTY_IN, GpeTrxClass.GPE_TRX_REFUND_CID)
        {
            checkNotNull(inAmt, "Refund:Req: Amount is mandatory\n");
            checkNull(GpePosLib.AddIntTag(prmTree, GpeRootTags.RTAG_AMT, inAmt), "Refund: Add amount TAG failed\n");

            if (inInvoiceNr != null && inCurrency != 0 && inCurrency.ToString().Length > 0)
                checkNull(GpePosLib.AddIntTag(prmTree, GpeRootTags.RTAG_CUR, inCurrency), "Refund:Req:: Add currency TAG failed\n");

            if (inInvoiceNr != null && inInvoiceNr.Length > 0)
                checkNull(GpePosLib.AddStringTag(prmTree, GpeRootTags.RTAG_INVOICE_NO, inInvoiceNr), "Refund:Req:: Add invoice TAG failed\n");
        }
    }
}
