#ifndef __ECR_TEST__
#define __ECR_TEST__

/* ********************************************************* Includes ****************/
#include "GpeEcrCommLib.h"

/* ********************************************************* Macro def. ************ */
#ifndef NULL
	#define NULL	0
#endif

#define ECRDLLNAME "GpeEcrCommLib.dll"

	typedef int (__GPESTDCALL *pFc_OpenLibrary) (char *);
	typedef int (__GPESTDCALL *pFc_CloseLibrary) (void);
	typedef int (__GPESTDCALL *pFc_GetVersion) (void);

	// transaction interface
	typedef int (__GPESTDCALL *pFc_Transaction) (int, int);
	// registration of the callbacks
	typedef int (__GPESTDCALL *pFc_RegCB_Display)(pFcDispCb);
	typedef int (__GPESTDCALL *pFc_RegCB_Print)(pFcPrnCb);
	typedef int (__GPESTDCALL *pFc_RegCB_Dialog)(pFcDlgCb);		
	// Parameters
	typedef int (__GPESTDCALL *pFc_CreatePrm)(int);
	typedef int (__GPESTDCALL *pFc_ReleasePrm)(int);
	typedef int (__GPESTDCALL *pFc_GetInputPrm)(int);
	typedef int (__GPESTDCALL *pFc_GetOutputPrm)(int);
	typedef int (__GPESTDCALL *pFc_AddStringTag)(int, int, char *);
	typedef int (__GPESTDCALL *pFc_AddIntTag)(int, int, int);
	typedef int (__GPESTDCALL *pFc_AddSubPrm)(int, int);
	typedef int (__GPESTDCALL *pFc_GetStringTag)(int, int, char *);
	typedef int (__GPESTDCALL *pFc_GetIntTag)(int, int);
	typedef int (__GPESTDCALL *pFc_GetSubPrmTag)(int, int);

typedef struct
{
	// Base functions
	pFc_OpenLibrary		GpePosLib_Open;
    pFc_CloseLibrary	GpePosLib_Close;
    pFc_GetVersion		GpePosLib_GetVersion;
	pFc_Transaction		GpePosLib_Transaction;
	// Callback
	pFc_RegCB_Display	GpePosLib_Display;
	pFc_RegCB_Print		GpePosLib_Print;
	pFc_RegCB_Dialog	GpePosLib_Dialog;
	// Parameters
	pFc_CreatePrm		GpePosLib_CreatePrmTree;
	pFc_ReleasePrm		GpePosLib_ReleaseTree;
	pFc_GetInputPrm		GpePosLib_GetInputTree;
	pFc_GetOutputPrm	GpePosLib_GetOutputTree;
	pFc_AddStringTag	GpePosLib_AddStringTag;
	pFc_AddIntTag		GpePosLib_AddIntTag;
	pFc_AddSubPrm		GpePosLib_AddSubTree;
	pFc_GetStringTag	GpePosLib_GetStringTag;
	pFc_GetIntTag		GpePosLib_GetIntTag;
	pFc_GetSubPrmTag	GpePosLib_GetSubTree;
}ecrIface_t;

/* ********************************************************* Type def. ************* */
#endif      // __ECR_TEST__