#ifndef __GPEECRCOMMLIB__
#define __GPEECRCOMMLIB__

/* ********************************************************* Includes ****************/

/* ********************************************************* Macro def. ************ */
#define POS_LIB_CC_STDCALL
//#define POS_LIB_CC_CDECL

#ifdef POS_LIB_CC_STDCALL
	#define __GPESTDCALL	__stdcall						// Rename the standard call as specific name which can be changed on this place, DO NOT CHANGE IT!
#else
	#define __GPESTDCALL	__cdecl							// Rename the standard call as specific name which can be changed on this place, DO NOT CHANGE IT!
#endif

#ifdef WIN32
    #include <Windows.h>

    #ifdef GPEECRCOMMLIB_EXPORTS
        #define DLL_IMPORT_EXPORT __declspec (dllexport)	// used for dll source code
    #else
        #define DLL_IMPORT_EXPORT __declspec (dllimport)	// used for host source code
    #endif
#endif


/* ********************************************************* Type def. ************* */
#ifndef NULL
	#define NULL 0
#endif


/**
	Return codes used by the DLL
*/
enum
{
// Common Errors
	GPE_OK						= 0,		// Success  no error occurred
	GPE_INPUT_PARAMS_ERR		= -1,		// No input parameters
	GPE_LIB_NOT_FOUND_ERR		= -2,		// Library not found or it cannot be loaded
	GPE_CB_NOT_REGISTERED       = -3,       // Callbacks dialog and prints are not regietred 
	GPE_GENERAL_ERR				= -10,		// General error  not further specified


// <-50/-99>	Application errors
	GPE_APP_IFACE_NOT_INIT_ERR	= -50,		// Application interface was not initialized
	GPE_APP_NO_APP_DATA_ERR		= -51,		// Application data is not available
	GPE_APP_DATA_NOT_VALID_ERR	= -52,		// Application data is not valid
	GPE_APP_MANDATORY_DATA_ERR	= -53,		// Bad or mismatches input parameters  mandatory data is missing
// Application - parameters
	GPE_APP_TAG_GENERAL_ERR		= -70,		// TLV Tree tag Error
	GPE_APP_TAG_FORMAT_ERR		= -71,
	GPE_APP_TAG_NOT_FOUND		= -72,
	GPE_APP_TAG_UNKNOWN_ERR		= -73,
// <-100 / -199>	Transaction errors
	GPE_TRX_PRC_INTERUPTED_ERR	= -100,		// Transaction process interrupted	
	GPE_TRX_IN_PROGRESS_ERR		= -108,		// Transaction is in the progress or terminal is busy	

// <-200 / -299>	Communication errors
	GPE_COMM_TERMINAL_NOT_FOUND_ERR	= -200,	// Terminal not found or terminal is not responding
	GPE_COMM_TERMINAL_RESP_TO_ERR	= -201,	// There is not response from the terminal  Response timeout
	GPE_COMM_TERMINAL_CORRUPTED_ERR	= -202,	// General communication error with the terminal  Communication corrupted, CRC or format errors
	GPE_COMM_OPEN_ERR				= -203,	// The communicaiton channel cannot be opened/inicitalized

// <-300 / - 500>	Unknown, undefined or system error  the reason is not specified, the transaction is in unknown state, detail in the log file
	GPE_UNEXPECED_ERR				= -300,	// Unexpected error, error which is not expected or handled by the DLL
	GPE_INTERNAL_ERR				= -500,	// Internal application error, error which cannot be handled by the DLL
};


/*
	Parameter tags
*/
typedef enum
{
	GPE_TRX_UNDEFINED_CID	= 0,
	GPE_TRX_PURCHASE_CID,			//	= 1,
	GPE_TRX_PURCHASE_CB_CID,		//	= 2,
	GPE_TRX_REFUND_CID,				//	= 3,	
	GPE_TRX_VOID_CID,				//	= 4, - Not-Supported yet
	GPE_TRX_PREAUTH_CID,			//	= 5, - 
	GPE_TRX_PRE_COMPL_CID,			//  = 6,
	GPE_TRX_CLOSE_TOTALS,			//	= 7,
	GPE_TRX_SUB_TOTALS,				//	= 8,
	GPE_TRX_NOT_UNKNOWN_CID,		//	= 9,
}TrxClassId_e;

typedef enum
{
	RTAG_ROOT		= 0,	// start tag
	RTAG_TID		= 1,	// Terminal ID	AN	6-9	[O] - Terminal identification. This number is registered in the authorization center.
	RTAG_TS			= 2,	// Timestamp	N	12	[O] - Timestamp of the transaction used by the protocol messages.
	RTAG_AMT		= 3,	// Amount	N	1-10	[I/O] - Amount must be >0 and < 9 999 999, 99. Amount must be without decimal places. If the currency supports decimal places the amount must be multiplied correspondingly (i.e. for CZK x 100).
	RTAG_CB_AMT		= 4,	// CBAmount	N	1-10	[I] - CashBack amount. The format is the same as Amount
	RTAG_CUR		= 5,	// Currency	N	3	[I] - Currency code according to ISO 4217 ??? (CZK 203, EUR 978, )
	RTAG_AUTH_CODE	= 6,	// Authorization Code	V	1-10	[I/O] - The authorization code identifies the transaction on the authorization host.
	RTAG_CARD		= 7,	// CardName	V	1-20	[O] - It specifies the name of card which it was used for the transaction.
	RTAG_PAN		= 8,	// PAN
	RTAG_RESPCODE	= 9,
	RTAG_INVOICE_NO	= 10,
	RTAG_EXPIRDATE	= 11,
	RTAG_CODEPAGE	= 12,
	RTAG_AID		= 13,	// AID	AN	1-24	[O] - It specifies the chip card application ID
	RTAG_SQNO		= 14,	// SequenceNo	N	1-10	[I/O] - It specifies the number for preauthorization and completion.
	RTAG_TRXNO		= 15,	// TrxId	N	12	[O] - Unique transaction ID generated on the terminal for each approved transaction.	
	RTAG_SUM		= 16,	// Summary	AN	Var	[I/O] - Totals summary which is compared with the host  not supported
	RTAG_RECEIPT_1	= 17,	// receipt for merchant (transactions and administrations)
	RTAG_RECEIPT_2	= 18,	// receipt for customer
	RTAG_END		= 99,	// End tag
}PRM_ROOT_TAGS_E;

typedef enum
{
	STAG_SUM_ROOT		= 100,
	STAG_DEBIT_COUNT	= 101,
	STAG_DEBIT_SUM		= 102,
	STAG_CREDIT_COUNT	= 103,
	STAG_CREDIT_SUM		= 104,
	STAG_CB_COUNT		= 105,
	STAG_CB_SUM			= 106,
	STAG_SUM_END		= 199,
}PRM_SUBROOT_TAGS;

typedef enum
{	
	IDX_ISO1	= 1,		// ISO-8859-1
	IDX_ISO2	= 2,		// ISO-8859-2
	IDX_ISO3	= 3,		// ISO-8895-3
	IDX_ISO5	= 5,		// ISO-8859-5
	IDX_END
}CP_IDX_E;

/**
	Defining the name of the exported function 
*/

#ifndef POS_LIB_CC_STDCALL
	// Base functions 
	#define GPEPOSLIB_OPENLIBRARY			"GpePosLib_OpenLibrary"
	#define GPEPOSLIB_CLOSELIBRARY 			"GpePosLib_CloseLibrary"
	#define GPEPOSLIB_GETVERSION			"GpePosLib_GetVersion"
	// callbacks functions
	#define GPEPOSLIB_REGISTER_PRINTCB		"GpePosLib_RegisterPrintCB"
	#define GPEPOSLIB_REGISTER_DISPLAYCB	"GpePosLib_RegisterDisplayCB"
	#define GPEPOSLIB_REGISTER_DIALOGCB		"GpePosLib_RegisterDialogCB"
	// transactions
	#define GPEPOSLIB_RUN_TRANSACTION		"GpePosLib_RunTransaction"
// parameters Tree	
	#define GPEPOSLIB_CREATE_PRM_TREE		"GpePosLib_CreatePrmTree"
	#define GPEPOSLIB_RELEASE_TREE			"GpePosLib_ReleaseTree"
	
	#define GPEPOSLIB_GET_INPUT_TREE		"GpePosLib_GetInputTree"
	#define GPEPOSLIB_GET_OUTPUT_TREE		"GpePosLib_GetOutputTree"
	
	#define GPEPOSLIB_ADD_STRING_TAG		"GpePosLib_AddStringTag"
	#define GPEPOSLIB_ADD_INT_TAG			"GpePosLib_AddIntTag"
	#define GPEPOSLIB_ADD_SUB_TREE			"GpePosLib_AddSubTree"
	
	#define GPEPOSLIB_GET_STRING_TAG		"GpePosLib_GetStringTag"
	#define GPEPOSLIB_GET_INT_TAG			"GpePosLib_GetIntTag"
	#define GPEPOSLIB_GET_SUB_TREE			"GpePosLib_GetSubTree"
#else 
	// Base functions 
	#define GPEPOSLIB_OPENLIBRARY			"_GpePosLib_OpenLibrary@4"
	#define GPEPOSLIB_CLOSELIBRARY 			"_GpePosLib_CloseLibrary@0"
	#define GPEPOSLIB_GETVERSION			"_GpePosLib_GetVersion@0"
	// callbacks functions
	#define GPEPOSLIB_REGISTER_PRINTCB		"_GpePosLib_RegisterPrintCB@4"
	#define GPEPOSLIB_REGISTER_DISPLAYCB	"_GpePosLib_RegisterDisplayCB@4"
	#define GPEPOSLIB_REGISTER_DIALOGCB		"_GpePosLib_RegisterDialogCB@4"
	// transactions
	#define GPEPOSLIB_RUN_TRANSACTION		"_GpePosLib_RunTransaction@8"
	// parameters Tree	
	#define GPEPOSLIB_CREATE_PRM_TREE		"_GpePosLib_CreatePrmTree@4"
	#define GPEPOSLIB_RELEASE_TREE			"_GpePosLib_ReleaseTree@4"
	
	#define GPEPOSLIB_GET_INPUT_TREE		"_GpePosLib_GetInputTree@4"
	#define GPEPOSLIB_GET_OUTPUT_TREE		"_GpePosLib_GetOutputTree@4"
	
	#define GPEPOSLIB_ADD_STRING_TAG		"_GpePosLib_AddStringTag@12"
	#define GPEPOSLIB_ADD_INT_TAG			"_GpePosLib_AddIntTag@12"
	#define GPEPOSLIB_ADD_SUB_TREE			"_GpePosLib_AddSubTree@8"
	
	#define GPEPOSLIB_GET_STRING_TAG		"_GpePosLib_GetStringTag@12"
	#define GPEPOSLIB_GET_INT_TAG			"_GpePosLib_GetIntTag@8"
	#define GPEPOSLIB_GET_SUB_TREE			"_GpePosLib_GetSubTree@8"
	// callbacks functions
	// transactions	
#endif

// indexs of the dialogs which can be registred
enum
{
	GPE_DIALOG_IDX_SIGNATURE_REQUIRED = 1,
	GPE_DIALOG_END							// all indexes MUST be lower than the Dialog end
};

//***************************************************************************************************
extern "C"		// exported with C name decoration
{
	typedef int (__GPESTDCALL *pFcDispCb)(char *, int, int);		// reference to function for Callbacks
	typedef int (__GPESTDCALL *pFcPrnCb) (char *, int, int, int);		// reference to function for Callbacks
	typedef int (__GPESTDCALL *pFcDlgCb) (int, int);				// reference to function for Callbacks

	DLL_IMPORT_EXPORT int __GPESTDCALL GpePosLib_OpenLibrary (char *pPathCfg);	
	DLL_IMPORT_EXPORT int __GPESTDCALL GpePosLib_CloseLibrary (void);	
	DLL_IMPORT_EXPORT int __GPESTDCALL GpePosLib_GetVersion (void);
	
	// callbacks functions
	DLL_IMPORT_EXPORT int __GPESTDCALL GpePosLib_RegisterDisplayCB (pFcDispCb pDispCB);
	DLL_IMPORT_EXPORT int __GPESTDCALL GpePosLib_RegisterPrintCB (pFcPrnCb pPrinterCB);
	DLL_IMPORT_EXPORT int __GPESTDCALL GpePosLib_RegisterDialogCB (pFcDlgCb pDialogCB);
		
	// transaction interface	
	DLL_IMPORT_EXPORT int __GPESTDCALL GpePosLib_RunTransaction (int classId, int rootId);

	// parameter interface
	DLL_IMPORT_EXPORT int __GPESTDCALL GpePosLib_CreatePrmTree (int classId);
	DLL_IMPORT_EXPORT int __GPESTDCALL GpePosLib_ReleaseTree (int rootId);
	DLL_IMPORT_EXPORT int __GPESTDCALL GpePosLib_GetInputTree(int tag);
	DLL_IMPORT_EXPORT int __GPESTDCALL GpePosLib_GetOutputTree(int tag);
	// add iFace
	DLL_IMPORT_EXPORT int __GPESTDCALL GpePosLib_AddStringTag (int treeId, int tag, char *pValue);
	DLL_IMPORT_EXPORT int __GPESTDCALL GpePosLib_AddIntTag (int treeId, int tag, int value);
	DLL_IMPORT_EXPORT int __GPESTDCALL GpePosLib_AddSubTree (int treeId, int tag);
	// get iFace
	DLL_IMPORT_EXPORT int __GPESTDCALL GpePosLib_GetStringTag (int treeId, int tag, char *pValue);
	DLL_IMPORT_EXPORT int __GPESTDCALL GpePosLib_GetIntTag (int treeId, int tag);
	DLL_IMPORT_EXPORT int __GPESTDCALL GpePosLib_GetSubTree (int treeId, int tag);
}

#endif      // end: __GPEECRCOMMLIB__