/*
    +-----------------------------------------------------------------------+
    |   File name :             Logger.cpp                                  |
    |   Description :           Diagnostic and debugging module             |
    |                                                                       |
    |   Creation date :         18-06-2009                                  |
    |                                                                       |
    |   @author:                Pavel Perman                                |
    |   @version:               1.0 (developed)                             |
    |   Copyright :             GPE                                         |
    |                                                                       |
    +-----------------------------------------------------------------------+
*/

#ifdef __cplusplus
    extern "C" {
#endif

#ifdef  WIN32
    #include <windows.h>
#else

#endif

#include <stdio.h>
#include "SystemApi.h"

static FILE *pFile; // TODO: zapouzdrit

/*---------------------------- Diagnostic part -----------------------------------*/
void DBG_Output(char *format, ...)
{   
    va_list args;
    char buff[256];             // work buffer

    memset(buff, 0, sizeof(buff));
    
    va_start(args, format);
    vsprintf(buff, format, args);
    va_end(args);

    #ifdef WIN32
        OutputDebugString(buff);
    #endif

}

void DBG_Logger(char *format, ...)
{   
    va_list args;
    char buff[244];             // work buffer
    char timebuff[25];

    memset(buff, 0, sizeof(buff));
    memset(timebuff, 0, sizeof(timebuff));

    SysApi_GetTimeStamp("[--,::]",timebuff);
    
    va_start(args, format);
    vsprintf(buff, format, args);
    va_end(args);
    
    fprintf(pFile, "%s:%s\n", timebuff, buff);
}

        
void DBG_OpenLogFile(char *pName)
{
    if(pName != NULL)
    {
        pFile = fopen (pName, "a+");
        if (pFile == NULL)
        {
            DBG_Output ("Error open/create logfile");
        }
        else
        {
            DBG_Output("Log file Opened");
            DBG_Logger("--------=| New Open Library |=---------\n");        
        }                     
    }
}

void DBG_CloseLogFile(void)   
{
    if(pFile != NULL)
        fclose (pFile);
}


#ifdef __cplusplus
    }
#endif