#ifndef  __SYSTEMAPI_
#define  __SYSTEMAPI_

#ifdef __cplusplus
    extern "C" {
#endif

#define     MS_WINDOWS_98  "MS WINDOWS 98"
#define     MS_WINDOWS_95  "MS WINDOWS 95"

#define     MAX_LOCK_NUMBER     3                   // maximalni pocet objeku k uzavreni sdilenych prostredku (Kritickych sekci)

#define     TS_MASK_LEN         7                   // maximlani delka masky pro T

#define     SYS_WAIT_INFINITE       (int) -1

        
typedef  void  *SysApi_HANDLE;                      // zcela obecny handle


typedef struct
{
    unsigned int hour;
    unsigned int min;
    unsigned int sec;        
}SysApi_Time_t; 

typedef struct
{
    unsigned int year;
    unsigned int month;
    unsigned int day;
}SysApi_Date_t;

// standarni funkce
unsigned long SysApi_GetTimeInMs(void);
int SysApi_GetDateTime(SysApi_Time_t *pTime, SysApi_Date_t *pDate);
int SysApi_GetTimeStamp(char *pMask, char *pTimeStamp);
//int SysApi_GetTimeStamp(char *pTimeStamp);
void SysApi_Clrscr(void);
int SysApi_ShellCmd(char const *pCmd);
void SysApi_Delay(unsigned int time_ms);

// synchronizacni funkce
SysApi_HANDLE SysApi_CreateThread(void *thProcedure, void *pParam);
SysApi_HANDLE SysApi_CreateEvent(char *pNameEvent);
int SysApi_WaitForSignal(SysApi_HANDLE syncEvent, unsigned long timeout);
int SysApi_SendSignal(SysApi_HANDLE syncEvent);

int SysApi_CloseResource(SysApi_HANDLE *closeHandle);
SysApi_HANDLE SysApi_CreateMutex(char * pMutexName);

SysApi_HANDLE   SysApi_CreateLockObject(void);
int SysApi_DeleteLockObject(SysApi_HANDLE handleCs);
int SysApi_UnlockObject(SysApi_HANDLE handleCs);
int SysApi_LockObject(SysApi_HANDLE handleCS);


int SysApi_WaitGetKey(void);            //TODO:

#ifdef __cplusplus
    }
#endif

#endif      //__SYSTEMAPI_TEMAPI_