#include <stdio.h>
#include <string.h>

#include "Ecr_Test.h"

typedef struct
{
	int debitCount;
	int creditCount;
	int cbCount;
	long long debitSum;
	long long creditSum;
	long long cbSum;
}totalsTransaction_t;


static totalsTransaction_t totals;

void Totals_incCountDebit(void)
{
	totals.debitCount++;
}
void Totals_incCountCredit(void)
{
	totals.creditCount++;
}

void Totals_incCountCashBack(void)
{
	totals.cbCount++;
}

void Totals_addDebitSum(int amtSum)
{
	totals.debitSum += amtSum;
}

void Totals_addCreditSum(int amtSum)
{
	totals.creditSum += amtSum;
}

void Totals_addCBSum(int amtSum)
{
	totals.cbSum += amtSum;
}

void Totals_clear(void)
{
	memset(&totals, 0, sizeof(totals));
}


int Totals_getTotalsDebitCount(void)
{
	return(totals.debitCount);
}
int Totals_getTotalsCreditCount(void)
{
	return(totals.creditCount);
}
int Totals_getTotalsCBCount(void)
{
	return(totals.cbCount);
}

int Totals_getTotalsDebitSum(char *pDebitSum)
{
	int ret = -1;
	if(pDebitSum != NULL)
	{
		if(totals.debitSum >= 0)
			sprintf(pDebitSum,"+%018u", totals.debitSum);
		else
			sprintf(pDebitSum,"-%018u", totals.debitSum);
		ret = 0;	
	}
	return(ret);
}

int Totals_getTotalsCreditSum(char *pCreditSum)
{
	int ret = -1;
	if(pCreditSum != NULL)
	{
		if(totals.creditSum >= 0)
			sprintf(pCreditSum,"+%018u", totals.creditSum);
		else
			sprintf(pCreditSum,"-%018u", totals.creditSum);
		ret = 0;
	}
	return(ret);
}

int Totals_getTotalsCBSum(char *pCBSum)
{
	int ret = -1;
	if(pCBSum != NULL)
	{
		if(totals.cbSum >= 0)
			sprintf(pCBSum,"+%018u", totals.cbSum);
		else
			sprintf(pCBSum,"-%018u", totals.cbSum);
		ret = 0;	
	}
	return(ret);
}

void Totals_print(void)
{
	printf("TOTAL:Debit Count:	%d\n", totals.debitCount);
	printf("TOTAL:Debit SUM:	%ld\n", totals.debitSum);
	
	printf("TOTAL:Credit Count:	%d\n", totals.creditCount);
	printf("TOTAL:Credit SUM:	%ld\n", totals.creditSum);
	
	printf("TOTAL:CB Count:		%d\n", totals.cbCount);
	printf("TOTAL:CB SUM:		%ld\n", totals.cbSum);	
}
